#ifndef PIECES_TOUR_HPP
#define PIECES_TOUR_HPP

#include "piece.hpp"

/// Tour dans le jeu d'échec
class Tour : public Piece {
	public:
		/// @brief Vérifie si un mouvement de la case origine à la case destination est valide
		/// @param org Case d'origine
		/// @param dest Destination
		/// @return Vrai si le mouvement est légal, faux sinon
		bool est_mouvement_legal(Square org, Square dest) const override;

		/// @brief Vérifie si la pièce est une menace pour l'adversaire
		/// @param org Position d'origine
		/// @param dest Position de destination
		/// @return true si la pièce est une menace, false sinon
		bool est_menace(Square org, Square dest) const override;

		using Piece::Piece;
};

#endif