#include "jeu.hpp"
#include <iostream>
#include <pieces/roi.hpp>
Jeu::Jeu(std::string name) : name(name) {
}

void Jeu::setup()
{
	this->echiquier.setup();
}

void Jeu::print() const
{
	std::cout << "Partie : " << this->name << ". Au tour des " << (player ? "Noirs" : "Blancs") << std::endl;
	this->echiquier.print_board();
	std::cout << message << " ";
}

std::string Jeu::canonical() const
{
	return echiquier.canonical_position() + " " + "";
}

bool Jeu::move(Square from, Square to) {
	Piece* piece = this->echiquier.get_piece(from);
	if(piece != nullptr && piece->get_color() != player) {
		this->set_message("Ce n'est pas votre tour.");
		return false;
	}
	if(this->echiquier.move(from, to, player)){
		player = (player == WHITE) ? BLACK : WHITE;
		return true;
	}
	this->set_message("Mouvement invalide.");
	return false;
}

Status Jeu::check_status() {
	if (echiquier.get_is_check()) {
		std::cout << (player == WHITE ? "Blanc " : "Noir ") << std::endl;
		return echiquier.check_check_mate(player) ? CHECK_MATE : ON_GOING;
	}

	return echiquier.check_stalemate(player) ? STALEMATE : ON_GOING;

}

bool Jeu::castling(bool big) {
	if(echiquier.castling(player, big)){
		player = (player == WHITE) ? BLACK : WHITE;
		return true;
	}
	return false;
}
