#include "pieces/fou.hpp"
#include "echiquier.hpp"

bool Fou::est_mouvement_legal(Square org, Square dest) const {
	int row_org, col_org, row_dest, col_dest;
	dest.get_row_col(row_dest, col_dest);
	org.get_row_col(row_org, col_org);

	// Cas de base
	if(!Piece::est_mouvement_legal(org, dest)) return false;

	if (abs(row_org - row_dest) == abs(col_org - col_dest))
	{
		// Vérification si aucune pièce n'est présente entre la case d'origine et de destination
		int direction_row = (row_dest - row_org) > 0 ? 1 : -1;
		int direction_col = (col_dest - col_org) > 0 ? 1 : -1;
		for (int row = row_org + direction_row, col = col_org + direction_col;
			 row != row_dest && col != col_dest;
			 row += direction_row, col += direction_col)
		{
			Piece* piece = echiquier->get_piece(Square(row, col));
			if (piece != nullptr)
				return false;
		}
		return true;
	} else {
		return false;
	}
}

bool Fou::est_menace(Square org, Square dest) const {
	return est_mouvement_legal(org, dest);
}